from . import AirVisualProData as AirVisualProData, AirVisualProEntity as AirVisualProEntity
from .const import DOMAIN as DOMAIN
from _typeshed import Incomplete
from collections.abc import Callable as Callable
from dataclasses import dataclass
from homeassistant.components.sensor import SensorDeviceClass as SensorDeviceClass, SensorEntity as SensorEntity, SensorEntityDescription as SensorEntityDescription, SensorStateClass as SensorStateClass
from homeassistant.config_entries import ConfigEntry as ConfigEntry
from homeassistant.const import CONCENTRATION_MICROGRAMS_PER_CUBIC_METER as CONCENTRATION_MICROGRAMS_PER_CUBIC_METER, CONCENTRATION_PARTS_PER_MILLION as CONCENTRATION_PARTS_PER_MILLION, EntityCategory as EntityCategory, PERCENTAGE as PERCENTAGE, UnitOfTemperature as UnitOfTemperature
from homeassistant.core import HomeAssistant as HomeAssistant, callback as callback
from homeassistant.helpers.entity_platform import AddEntitiesCallback as AddEntitiesCallback
from typing import Any

@dataclass(frozen=True)
class AirVisualProMeasurementKeyMixin:
    value_fn: Callable[[dict[str, Any], dict[str, Any], dict[str, Any], dict[str, Any]], float | int]
    def __init__(self, value_fn) -> None: ...

@dataclass(frozen=True)
class AirVisualProMeasurementDescription(SensorEntityDescription, AirVisualProMeasurementKeyMixin):
    def __init__(self, value_fn, *, key, device_class, entity_category, entity_registry_enabled_default, entity_registry_visible_default, force_update, icon, has_entity_name, name, translation_key, unit_of_measurement, last_reset, native_unit_of_measurement, options, state_class, suggested_display_precision, suggested_unit_of_measurement) -> None: ...

SENSOR_DESCRIPTIONS: Incomplete

def async_get_aqi_locale(settings: dict[str, Any]) -> str: ...
async def async_setup_entry(hass: HomeAssistant, entry: ConfigEntry, async_add_entities: AddEntitiesCallback) -> None: ...

class AirVisualProSensor(AirVisualProEntity, SensorEntity):
    _attr_has_entity_name: bool
    entity_description: AirVisualProMeasurementDescription
    @property
    def native_value(self) -> float | int: ...
